package api

import "html/template"

var listEndpointDataHTML, _ = template.New(`listEndpointDataHTML`).Parse(`
<html>
  <head>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-eOJMYsd53ii+scO/bJGFsiCZc+5NDVN2yr8+0RDqr0Ql0h+rP48ckxlpbzKgwra6" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta3/dist/js/bootstrap.bundle.min.js" integrity="sha384-JEW9xMcG8R+pH31jmWH6WWP0WintQrMb4s7ZOdauHnUtxwoG2vI5DkLtS3qm9Ekf" crossorigin="anonymous"></script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/handlebars@latest/dist/handlebars.js"></script>
  </head>

  <body>

    <div class="container">
      <div>
        <h1>
          Fingerbank Collector endpoints list
        </h1>
      </div>
		
			<div class="card">
				<div class="card-body">
					<h5 class="card-title">Endpoints detected by the collector</h5>

					<table class="table">
						<thead>
							<th>MAC address</th>
							<th>IP address</th>
							<th>Device</th>
							<th>Version</th>
							<th>OS</th>
							<th>Manufacturer</th>
							<th>Confidence</th>
						</thead>
						<tbody>
							{{ range .Endpoints }}
							<tr>
								<td>{{.EndpointData.MAC}}</td>
								<td>{{.EndpointData.IP}}</td>
								<td>{{.CloudAPIResult.Device.Name}}</td>
								<td>{{.CloudAPIResult.Version}}</td>
								<td>{{.CloudAPIResult.OperatingSystem.Name}}</td>
								<td>{{.CloudAPIResult.Manufacturer.Name}}</td>
								<td>{{.CloudAPIResult.Score}}</td>
							</tr>
							{{ end }}
						</tbody>
					</table>
				</div>
			</div>

    </div>

  </body>
</html>
`)
