package api

import (
	"net/http"

	"github.com/gin-gonic/gin"
)

func listPeers(c *gin.Context) {
	lockid := collector.EndpointsDataRLock()
	defer collector.EndpointsDataRUnlock(lockid)

	c.JSON(http.StatusOK, gin.H{
		"oda_peers":      collector.ReplicationController.GetODAPeers(),
		"inbound_peers":  collector.ReplicationController.GetInboundPeers(),
		"outbound_peers": collector.ReplicationController.GetOutboundPeers(),
	})
}
