// This file is automatically generated using tools/generate_delta_endpoint_data.go
// Changes to this file will be overwritten on the next build
package fccommon

import (
	"strconv"
	"time"
)

type DeltaEndpointData struct {
	CreatedAt                 *time.Time                       `json:"created_at,omitempty"`
	LastUpdated               *time.Time                       `json:"last_updated,omitempty"`
	UUID                      string                           `json:",omitempty"`
	MostAccurateUserAgent     string                           `json:"most_accurate_user_agent,omitempty"`
	UserAgents                map[string]int                   `json:"user_agents,omitempty"`
	DhcpFingerprint           string                           `json:"dhcp_fingerprint,omitempty"`
	DhcpVendor                string                           `json:"dhcp_vendor,omitempty"`
	Dhcp6Fingerprint          string                           `json:"dhcp6_fingerprint,omitempty"`
	Dhcp6Enterprise           string                           `json:"dhcp6_enterprise,omitempty"`
	Hostname                  string                           `json:"hostname,omitempty"`
	OUI                       string                           `json:"oui,omitempty"`
	DestinationHosts          map[string]map[string]int        `json:"destination_hosts,omitempty"`
	UPnP                      string                           `json:"upnp,omitempty"`
	UPnPURNs                  map[string]int                   `json:"upnp_urn,omitempty"`
	UPnPServices              map[string]int                   `json:"upnp_services,omitempty"`
	UPnPDevices               map[string]int                   `json:"upnp_devices,omitempty"`
	UPnPServerStrings         map[string]int                   `json:"upnp_server_strings,omitempty"`
	UPnPUserAgents            map[string]int                   `json:"upnp_user_agents,omitempty"`
	MDNSRequests              map[string]int                   `json:"mdns_requests,omitempty"`
	MDNSServices              map[string]int                   `json:"mdns_services,omitempty"`
	TCPSynSignatures          map[string]int                   `json:"tcp_syn_signatures,omitempty"`
	TCPSynAckSignatures       map[string]int                   `json:"tcp_syn_ack_signatures,omitempty"`
	LLDPCapabilities          map[string]bool                  `json:"lldp_capabilities,omitempty"`
	CDPCapabilities           map[string]bool                  `json:"cdp_capabilities,omitempty"`
	JA3Fingerprints           map[string]int                   `json:"ja3_fingerprints,omitempty"`
	BlacklistedCommunications map[string]map[int]TrackableTime `json:"blacklisted_communications,omitempty"`
	ClientHints               map[string]map[string]string     `json:"client_hints,omitempty"`
	JA3Data                   map[string]map[string]int        `json:"ja3_data,omitempty"`
	DPISignatures             map[string]int                   `json:"dpi_signatures,omitempty"`
	FromPorts                 map[string]int                   `json:"from_ports,omitempty"`
	ToPorts                   map[string]int                   `json:"to_ports,omitempty"`
}

func addEventsMapIntInt(events *[]string, timestamp, field string, v1, v2 map[int]int) {
	for k, v := range v2 {
		if val, found := v1[k]; !found || v != val {
			*events = append(*events, timestamp+":"+field+":"+strconv.Itoa(k))
		}
	}
}

func addEventsMapStringInt(events *[]string, timestamp, field string, v1, v2 map[string]int) {
	for k, v := range v2 {
		if val, found := v1[k]; !found || v != val {
			*events = append(*events, timestamp+":"+field+":"+k)
		}
	}
}

func addEventsMapStringIntInt(events *[]string, timestamp, field string, v1, v2 map[string]map[int]int) {
	for k, v := range v2 {
		addEventsMapIntInt(events, timestamp, field+":"+k, v1[k], v)
	}
}

func addEventsMapStringStringInt(events *[]string, timestamp, field string, v1, v2 map[string]map[string]int) {
	for k, v := range v2 {
		addEventsMapStringInt(events, timestamp, field+":"+k, v1[k], v)
	}
}

func addEventsString(events *[]string, timestamp, field string, v1, v2 string) {
	if v2 != "" && v1 != v2 {
		*events = append(*events, string(timestamp+":"+field+":"+v2))
	}
}

func addEventsBootSequences(events *[]string, v1, v2 map[string]bool) {
	if len(v1) >= len(v2) {
		return
	}

	for e, _ := range v2 {
		if _, found := v1[e]; !found {
			*events = append(*events, e)
		}
	}
}

func EndpointDataDiffEvents(ts time.Time, v1, v2 *EndpointData) ([]string, []string) {
	events := []string{}
	bootEvents := []string{}
	timestamp := strconv.FormatInt(ts.Unix()*1000, 10)
	addEventsBootSequences(&bootEvents, v1.BootSequence.Events, v2.BootSequence.Events)
	addEventsString(&events, timestamp, "most_accurate_user_agent", v1.MostAccurateUserAgent, v2.MostAccurateUserAgent)
	addEventsMapStringInt(&events, timestamp, "user_agents", v1.UserAgents, v2.UserAgents)
	addEventsString(&events, timestamp, "dhcp_fingerprint", v1.DhcpFingerprint, v2.DhcpFingerprint)
	addEventsString(&events, timestamp, "dhcp_vendor", v1.DhcpVendor, v2.DhcpVendor)
	addEventsString(&events, timestamp, "dhcp6_fingerprint", v1.Dhcp6Fingerprint, v2.Dhcp6Fingerprint)
	addEventsString(&events, timestamp, "dhcp6_enterprise", v1.Dhcp6Enterprise, v2.Dhcp6Enterprise)
	addEventsString(&events, timestamp, "hostname", v1.Hostname, v2.Hostname)
	addEventsString(&events, timestamp, "oui", v1.OUI, v2.OUI)
	addEventsMapStringStringInt(&events, timestamp, "destination_hosts", v1.DestinationHosts, v2.DestinationHosts)
	addEventsString(&events, timestamp, "upnp", v1.UPnP, v2.UPnP)
	addEventsMapStringInt(&events, timestamp, "upnp_urn", v1.UPnPURNs, v2.UPnPURNs)
	addEventsMapStringInt(&events, timestamp, "upnp_services", v1.UPnPServices, v2.UPnPServices)
	addEventsMapStringInt(&events, timestamp, "upnp_devices", v1.UPnPDevices, v2.UPnPDevices)
	addEventsMapStringInt(&events, timestamp, "upnp_server_strings", v1.UPnPServerStrings, v2.UPnPServerStrings)
	addEventsMapStringInt(&events, timestamp, "upnp_user_agents", v1.UPnPUserAgents, v2.UPnPUserAgents)
	addEventsMapStringInt(&events, timestamp, "mdns_requests", v1.MDNSRequests, v2.MDNSRequests)
	addEventsMapStringInt(&events, timestamp, "mdns_services", v1.MDNSServices, v2.MDNSServices)
	addEventsMapStringInt(&events, timestamp, "tcp_syn_signatures", v1.TCPSynSignatures, v2.TCPSynSignatures)
	addEventsMapStringInt(&events, timestamp, "tcp_syn_ack_signatures", v1.TCPSynAckSignatures, v2.TCPSynAckSignatures)
	addEventsMapStringInt(&events, timestamp, "ja3_fingerprints", v1.JA3Fingerprints, v2.JA3Fingerprints)
	addEventsMapStringStringInt(&events, timestamp, "ja3_data", v1.JA3Data, v2.JA3Data)
	addEventsMapStringInt(&events, timestamp, "dpi_signatures", v1.DPISignatures, v2.DPISignatures)
	addEventsMapStringInt(&events, timestamp, "from_ports", v1.FromPorts, v2.FromPorts)
	addEventsMapStringInt(&events, timestamp, "to_ports", v1.ToPorts, v2.ToPorts)

	return bootEvents, events
}
