package fccommon

import (
	"fmt"
	"net"

	"git.inverse.ca/inverse/fingerbank-collector/dpi"
)

func (fc *FingerbankCollector) processPacketDPI(m dpi.Metadata, signatures []string) {
	fc.processPacketDPIForIP(m, signatures, m.GetSrcIP(), m.GetDstIP(), m.GetSrcPort(), m.GetDstPort())
	fc.processPacketDPIForIP(m, signatures, m.GetDstIP(), m.GetSrcIP(), m.GetDstPort(), m.GetSrcPort())
}

func (fc *FingerbankCollector) processPacketDPIForIP(m dpi.Metadata, signatures []string, ip1 net.IP, ip2 net.IP, port1 uint16, port2 uint16) {
	ed, err := fc.FindEndpointDataIP(ip1.String())
	if err != nil {
		return
	} else {
		cleanSigs := []string{}
		ip2dhost, _ := fc.EndpointIpToHost(ed.mac, ip2.String())
		for _, sig := range signatures {
			if !dpiIgnoreSignatures[sig] {
				if ip2dhost == "" {
					ip2dhost = "*"
				}
				sig += fmt.Sprintf(":%s:%s:%d:%d", ip2dhost, m.GetProto(), port1, port2)
				cleanSigs = append(cleanSigs, sig)
			}
		}
		ed.AddDPISignatures(cleanSigs)
	}
}
