package fcreplication

// DO NOT ADD ANYTHING MANUALLY TO THIS FILE
// This file should automatically be generated using 'make common/replication/custom_handler.go'

import (
	"net"
)

func (ctrl *Controller) customHandleEncryptedPacket(msg ReplicationMessage, peerIP net.IP) (bool, ReplicationMessage, error) {
	var resp ReplicationMessage
	var err error
	switch msg.Type {

	case 32:
		var p REPEndpointDataUpdate
		err = ctrl.decodePacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 34:
		var p REPEndpointDataReplace
		err = ctrl.decodePacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 35:
		var p REPEndpointDataDelete
		err = ctrl.decodePacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 33:
		var p REPIpMacUpdate
		err = ctrl.decodePacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 36:
		var p REPAddIpHostMapping
		err = ctrl.decodePacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 37:
		var p REPAddDestinationHost
		err = ctrl.decodePacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 38:
		var p REPResetEndpointCache
		err = ctrl.decodePacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	}

	return false, resp, nil
}

func (ctrl *Controller) customHandleUnencryptedPacket(msg UnencryptedReplicationMessage, peerIP net.IP) (bool, ReplicationMessage, error) {
	var resp ReplicationMessage
	var err error
	switch msg.Type {

	case 32:
		var p REPEndpointDataUpdate
		err = ctrl.decodeUnencryptedPacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 34:
		var p REPEndpointDataReplace
		err = ctrl.decodeUnencryptedPacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 35:
		var p REPEndpointDataDelete
		err = ctrl.decodeUnencryptedPacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 33:
		var p REPIpMacUpdate
		err = ctrl.decodeUnencryptedPacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 36:
		var p REPAddIpHostMapping
		err = ctrl.decodeUnencryptedPacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 37:
		var p REPAddDestinationHost
		err = ctrl.decodeUnencryptedPacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	case 38:
		var p REPResetEndpointCache
		err = ctrl.decodeUnencryptedPacketContent(msg, &p)
		if err != nil {
			return true, resp, err
		}
		resp = ctrl.dispatchActionMap(msg.Type, p)
		return true, resp, err

	}

	return false, resp, nil
}
