package main

import (
	"html/template"
	"os"
	"reflect"
	"strings"

	"github.com/inverse-inc/go-utils/sharedutils"

	fccommon "git.inverse.ca/inverse/fingerbank-collector/common"
)

type TemplateDataHandler struct {
	MsgType      uint8
	DecodeInType string
}

type TemplateData struct {
	Handlers []TemplateDataHandler
}

func main() {
	collector := fccommon.NewFingerbankCollector("dummy")

	templateData := TemplateData{Handlers: []TemplateDataHandler{}}
	for _, meta := range collector.ReplicationControllerMeta() {
		tdh := TemplateDataHandler{}
		tdh.MsgType = meta.ActionID
		tdh.DecodeInType = strings.TrimPrefix(reflect.TypeOf(meta.DecodeInStruct).String(), "fcreplication.")
		templateData.Handlers = append(templateData.Handlers, tdh)
	}

	t, err := template.ParseFiles("common/replication/handlergenerator/handlers.template")
	sharedutils.CheckError(err)

	t.Execute(os.Stdout, templateData)
}
