package fingerbankclient

type InterrogateQuery struct {
	BootSequence        []string                     `json:"boot_sequence"`
	ClientHints         map[string]map[string]string `json:"client_hints"`
	DestinationHosts    []string                     `json:"destination_hosts"`
	Destinations        map[string][]int             `json:"destinations"`
	Dhcp6Enterprise     string                       `json:"dhcp6_enterprise"`
	Dhcp6Fingerprint    string                       `json:"dhcp6_fingerprint"`
	DhcpFingerprint     string                       `json:"dhcp_fingerprint"`
	DhcpVendor          string                       `json:"dhcp_vendor"`
	DPISignatures       []string                     `json:"dpi_signatures"`
	Hostname            string                       `json:"hostname"`
	JA3Data             map[string][]string          `json:"ja3_data"`
	JA3Fingerprints     []string                     `json:"ja3_fingerprints"`
	MDNSServices        []string                     `json:"mdns_services"`
	MacVendor           string                       `json:"mac_vendor"`
	Ports               []string                     `json:"ports"`
	TCPSynAckSignatures []string                     `json:"tcp_syn_ack_signatures"`
	TCPSynSignatures    []string                     `json:"tcp_syn_signatures"`
	UPnPServerStrings   []string                     `json:"upnp_server_strings"`
	UPnPUserAgents      []string                     `json:"upnp_user_agents"`
	UserAgents          []string                     `json:"user_agents"`
}

type InterrogateResponse struct {
	DeviceName      string `json:"device_name"`
	Device          Device `json:"device"`
	Score           int    `json:"score"`
	Version         string `json:"version"`
	Manufacturer    Device `json:"manufacturer"`
	OperatingSystem Device `json:"operating_system"`
	RequestId       string `json:"request_id"`
}

type NetworkProfile struct {
	DestinationHosts    []string `json:"destination_host"`
	DhcpFingerprints    []string `json:"dhcp_fingerprint"`
	DhcpVendors         []string `json:"dhcp_vendor"`
	Hostnames           []string `json:"hostname"`
	MdnsServices        []string `json:"mdns_service"`
	OUIs                []string `json:"oui"`
	TcpSynSignatures    []string `json: tcp_syn_signature"`
	TcpSynAckSignatures []string `json:"tcp_syn_ack_signature"`
	UpnpServerStrings   []string `json:"upnp_server_string"`
	UpnpUserAgents      []string `json:"upnp_user_agent"`
	UserAgents          []string `json:"user_agent"`
}

type EndpointIsAResponse struct {
	Result  bool   `json:"result"`
	Message string `json:"message"`
}

type Device struct {
	CreatedAt       string   `json:"created_at"`
	Id              int      `json:"id"`
	Name            string   `json:"name"`
	ParentId        int      `json:"parent_id"`
	VirtualParentId int      `json:"virtual_parent_id"`
	Parents         []Device `json:"parents"`
}
