package fcallnoophandler

import "git.inverse.ca/inverse/fingerbank-collector/common"

type AllnoopHandler struct {
	fccommon.GenericHandler
}

const (
	Name       = "allnoop"
	DefaultBPF = "tcp or udp"
)

// Create a new handler
func NewAllnoopHandler(collector fccommon.Collector) fccommon.ProtocolHandler {
	eh := &AllnoopHandler{}
	eh.Collector = collector
	return eh
}

// Handle function to process a packet
// info is the PacketInfo associated to this connection
// l4Payload is the bytes of the TCP or UDP packet
// rawPacket is the bytes of the packet as received on the wire
func (h *AllnoopHandler) Handle(info fccommon.PacketInfo, l4Payload []byte, rawPacket []byte) {
	return
}

// Returns the BPF of the packets the protocol handler is interested in
func (h *AllnoopHandler) GetBPF() string {
	return DefaultBPF
}

// Friendly string representation of this protocol handler
func (h *AllnoopHandler) String() string {
	return "All noop Handler"
}

// Name that represents this protocol handler
// Should return a value following the golang package naming standards
func (h *AllnoopHandler) Name() string {
	return Name
}
