package fcarphandler

import (
	"encoding/hex"
	"testing"

	"git.inverse.ca/inverse/fingerbank-collector/common"
)

func TestHandle(t *testing.T) {
	h := NewARPHandler(fccommon.NewFingerbankCollector("")).(*ARPHandler)

	// ARP request
	// SHA: f4:Ea:67:e5:65:8a
	// SPA: 0.0.0.0
	// DHA: 00:0c:29:30:e2:02
	// DPA: 172.21.110.1
	hexRawPacket := "000c2930e202f4ea67e5658a08060001080006040001f4ea67e5658a00000000000c2930e202ac156e01000000000000000000000000000000000000"
	rawPacket, _ := hex.DecodeString(hexRawPacket)

	h.Handle(fccommon.PacketInfo{}, []byte(""), rawPacket)

	mac, err := h.Collector.IP2MAC("172.21.110.1")

	if err != nil || mac != "000c2930e202" {
		t.Error("Handle didn't create the proper IP2MAC entry")
	}
}
