package fclog

import (
	"github.com/inconshreveable/log15"
	ilog "github.com/inverse-inc/go-utils/log"
	"github.com/inverse-inc/go-utils/sharedutils"
)

// Get a Fingerbank Collector logger based on the Inverse but without the need to use it through a context
// Passing an empty level will attempt to read the level from the environment and then default to INFO
func Logger(level string) log15.Logger {
	ctx := ilog.LoggerDummyContext()

	// Set the level if needed
	if level == "" {
		level = sharedutils.EnvOrDefault("LOG_LEVEL", "INFO")
	}

	ctx = ilog.LoggerSetLevel(ctx, level)
	return ilog.LoggerWContext(ctx)
}
