#==============================================================================
# Variables
#==============================================================================
%global     debug_package %{nil}

#==============================================================================
# Main package
#==============================================================================
Name:       fingerbank-collector
Version:    1.4.2
Release:    1%{?dist}
ExclusiveArch:  x86_64
Summary:    An exhaustive device profiling tool
Packager:   Inverse inc. <info@inverse.ca>
Group:      System Environment/Daemons
License:    GPL
URL:        http://www.fingerbank.org/

Source0:    %{name}-%{version}.tar
BuildRoot:  %{_tmppath}/%{name}-root

BuildRequires: tar, wget, libpcap-devel, gcc
Requires: libpcap

%description
Fingerbank collector for usage only with a PacketFence installation


%pre

#==============================================================================
# Source preparation
#==============================================================================
%prep
%setup -q -n %{name}-%{version}

#==============================================================================
# Build
#==============================================================================
%build
%{__make} fingerbank-collector-classic-pf

#==============================================================================
# Installation
#============================================================================
%install
# /usr/local/fingerbank
rm -rf %{buildroot}
%{__install} -d %{buildroot}/usr/local/fingerbank
%{__install} -d %{buildroot}/usr/local/fingerbank/collector
mv fingerbank-collector %{buildroot}/usr/local/fingerbank/collector
%{__install} -D -m0644 build/packetfence-fingerbank-collector.service %{buildroot}/usr/lib/systemd/system/packetfence-fingerbank-collector.service
%{__install} -D -m0644 build/set-env-fingerbank-conf.pl %{buildroot}/usr/local/fingerbank/collector/set-env-fingerbank-conf.pl

#==============================================================================
# Post Installation
#==============================================================================
%post
systemctl daemon-reload

%clean
rm -rf %{buildroot}


%postun


%files
%defattr(664,fingerbank,fingerbank,2775)
%dir                                /usr/local/fingerbank
                                    /usr/local/fingerbank/*
%attr(755,fingerbank,fingerbank)    /usr/local/fingerbank/collector/fingerbank-collector
%attr(755,fingerbank,fingerbank)    /usr/local/fingerbank/collector/set-env-fingerbank-conf.pl

%attr(0644, root, root)             /usr/lib/systemd/system/packetfence-fingerbank-collector.service


%changelog
* Tue Dec 27 2022 Inverse <info@inverse.ca> - 1.4.2-1
- Adapt spec file to CI
